/*
    DIG server exmaple

    Filename: dig_server_query_processing1.pl
    Author: Zhisheng Huang <huang@cs.vu.nl>
    Last modified: 5 July, 2004
*/


:-use_module(library('dig/dig_client')).
:-use_module(library('dig/dig_server')).
:-use_module(library('dig/dig_process')).
:-use_module(library('dig/dig_db')).
:-use_module(library('http/thread_httpd')).


%:-use_module(library('dialog/pretty_print')). 


%% This is an exmaple in which the Prolog DIG server picks up just a
%% satisfiablability query, then asks it.


%deal with the ask request, pickup a satisfiability query only.
my_dig_server_processing(RequestData, Answer, _Options):-
			dig_requestdata_analysis(RequestData, Data, Type),
			Type=asks,
			dig_data_analysis(Data, satisfiable, E, _OtherData),
			dig_ask(elements([E]), Answer, [connection(close)]),
			true.


%deal with other request
my_dig_server_processing(RequestData, Answer, Options):-
			dig_post(RequestData, Answer, Options).




			



			

:- dig_server_port(Port), set_dig_server_id('SWI-Prolog DIG Server (Satisfiability Queries Only)'), http_server(dig_server,[port(Port)]).



